PROGRAM hubble
  IMPLICIT NONE
  INTEGER:: steps,contatore,i,j,k
  REAL*8, ALLOCATABLE:: ceph_cat(:,:),velRec(:),velRecError(:),w(:)
  REAL*8:: MagAss(4),errMagAss(4), magRel(4), moduloDist(4), distanzaGalassia(4), errDist(4), dDist, errModDist, devStdMagRel(4)
  REAL*8:: periodo(4),devStdPer(4),sumW,tot2(4),errtot(4), mediaH, errMediaH
  REAL*8:: magMedia,devStdMag,periodoMedio,devStdPeriodo,sommaden, sommanum
  REAL*8:: sumXq, sumX, sumY, sumXY, A, B, Delta, sumYaX, sigmaA, sigmaB, sigmaY, logPeriodo, errLogPeriodo, errLogP_B
  CHARACTER(LEN=16):: nameTmp	
  
  steps=1000
  
	55 FORMAT((x,f6.2),A,(x,f6.2),A)
	90 FORMAT(2(x,f10.4)) !prende 2 volte lo stesso formato f10.4
    91 FORMAT(5(x,f10.4)) !prende 5 volte lo stesso formato f10.4
    92 FORMAT(i3, 3(x,f12.6)) !prende 3 volte lo stesso formato f12.6
    93 FORMAT(8(x,f10.4)) !prende 8 volte lo stesso formato f10.4

! chiamo la subroutine 4 volte, per ogni Cepheide

  CALL spline("ceph_ic_4182.dat",steps,magMedia,devStdMag,periodoMedio,devStdPeriodo)
  magRel(1)=magMedia
  devStdMagRel(1)=devStdMag
  periodo(1)=periodoMedio
  devStdPer(1)=devStdPeriodo
  
  CALL spline("ceph_ngc0925.dat",steps,magMedia,devStdMag,periodoMedio,devStdPeriodo)
  magRel(2)=magMedia
  devStdMagRel(2)=devStdMag
  periodo(2)=periodoMedio
  devStdPer(2)=devStdPeriodo
  
  CALL spline("ceph_ngc1425.dat",steps,magMedia,devStdMag,periodoMedio,devStdPeriodo)
  magRel(3)=magMedia
  devStdMagRel(3)=devStdMag
  periodo(3)=periodoMedio
  devStdPer(3)=devStdPeriodo
  
  CALL spline("ceph_ngc4725.dat",steps,magMedia,devStdMag,periodoMedio,devStdPeriodo)
  magRel(4)=magMedia
  devStdMagRel(4)=devStdMag
  periodo(4)=periodoMedio
  devStdPer(4)=devStdPeriodo
  
  PRINT *,
  PRINT *, "MAGNITUDINE REL con ERRORI"
  WRITE(*,93) magRel(1),devStdMagRel(1)
  WRITE(*,93) magRel(2),devStdMagRel(2)
  WRITE(*,93) magRel(3),devStdMagRel(3)
  WRITE(*,93) magRel(4),devStdMagRel(4)

  PRINT *, "PERIODO MEDIO con ERRORI"
  WRITE(*,93) periodo(1),devStdPer(1)
  WRITE(*,93) periodo(2),devStdPer(2)
  WRITE(*,93) periodo(3),devStdPer(3)
  WRITE(*,93) periodo(4),devStdPer(4)
  
! Leggi il file con i dati del catalogo Cepheidi
  OPEN(99, file="ceph_catalog.dat")
  contatore=0
  DO !conta i dati nel file
  	READ(99,*, END=888) !888 è un etichetta di riga/label a cui saltare
  	contatore=contatore+1
  END DO
  888 CONTINUE !label uscita ciclo count 
  
  PRINT *,
  PRINT *, "dati cefeidi (ceph_catalog.dat)=",contatore
  REWIND 99 !riavvolge il file dati 99 dall'inizio
  
  ALLOCATE(ceph_cat(2,contatore))
  
  DO j=1,contatore
	READ(99,*) (ceph_cat(i,j), i=1,2) !è un ciclo DO su una sola riga
  END DO

! plot del grafico Cepheidi
! disenga la curva con gnuPlot
OPEN(UNIT=48,FILE="data")
DO i=1,contatore
    logPeriodo=log(ceph_cat(1,i))
	WRITE(48,*) logPeriodo, ceph_cat(2,i)
END DO
CLOSE(48)

CALL SYSTEM("gnuplot -p data_plot_ceph.plt")

! Calcola il FIT - Regressione Lineare - (migliore retta che interpola i punti)
  sumXq=0.
  sumX=0.
  sumY=0.
  sumXY=0.		
  sumYaX=0.
  DO j=1, contatore
	sumXq=sumXq+log10(ceph_cat(1,j))**2
	sumX=sumX+log10(ceph_cat(1,j))
	sumY=sumY+ceph_cat(2,j)
	sumXY=sumXY+log10(ceph_cat(1,j))*ceph_cat(2,j)		
  END DO
  Delta=contatore*sumXq-sumX*sumX
  A=(sumXq*sumY-sumX*sumXY)/Delta
  B=(contatore*sumXY-sumX*sumY)/Delta
  
  ! calcolo degli errori su A e B
  DO j=1, contatore
	sumYaX=sumYaX+(ceph_cat(2,j)-B*log10(ceph_cat(1,j))-A)**2
  END DO
  sigmaY=sqrt((1./(contatore-2))*sumYaX)
  sigmaA=sigmaY*sqrt(contatore/Delta)
  sigmaB=sigmaY*sqrt(sumXq/Delta)
  PRINT *, "Regressione Lineare sui dati ceph_catalog.dat"
  PRINT *, "A (intersezione) =", A, "sigma A =", sigmaA
  PRINT *, "B (pendenza)     =", B, "sigma B =", sigmaB
  PRINT *, "A e B con arrotondamento alla 4a cifra decimale"
  WRITE(*,93) A,sigmaA
  WRITE(*,93) B,sigmaB
  PRINT *, 
 !calcolo la Mag Assoluta delle 4 cefeidi partendo dal periodo (Mag=B*log(Periodo)+A), 
 !il modulo di distanza e la DISTANZA della Galassia e relativi errori
  DO i=1,4
    MagAss(i)=B*log10(periodo(i))+A
	moduloDist(i)=magRel(i)- MagAss(i)
    distanzaGalassia(i)=(10**((0.2*moduloDist(i))+1.))/(10**6)
	
	errLogPeriodo=devStdPer(i)/periodo(i)
	errLogP_B=sqrt((B**2)*(errLogPeriodo**2)+(log10(periodo(i))**2)*(sigmaB**2))
    errMagAss(i)=sqrt((errLogP_B**2)+(sigmaA**2))

	dDist=(10**((0.2*moduloDist(i))+1))*log(10.)*0.2/(10**6)
	errModDist=errMagAss(i)
	errDist(i)=dDist*errModDist
	
	PRINT *, i
    54 FORMAT(A,(x,f7.3),A,(x,f7.3))

	WRITE (*,54) "  Mag Assoluta=",MagAss(i),"  errore Mag.Ass.=",errMagAss(i)
	WRITE (*,54) "  Dist Galassia (Mpc)=",distanzaGalassia(i),"  errore Dist=",errDist(i)
 	PRINT *,
  END DO 
  
 ! carico i dati di velocità dal file gal_vel.dat fornito
  OPEN(1, file="gal_vel.dat")
  contatore=0
  DO !conta i dati nel file
  	READ(1,*, END=999) 
  	contatore=contatore+1
  END DO
  999 CONTINUE !label uscita ciclo count 
  REWIND 1 !riavvolge il file dati 1 dall'inizio
  ALLOCATE(velRec(contatore))
  ALLOCATE(velRecError(contatore))
  ALLOCATE(w(contatore))
  DO j=1,contatore
	READ(1,*) nameTmp,nameTmp,velRec(j),velRecError(j)
  END DO
  PRINT *, "Velocità di regressione con relativo errore (file gal_vel.dat)"
  DO j=1, contatore
	WRITE(*,90) velRec(j),velRecError(j)
  END DO

! PLOT DEL GRAFICO Distanza-Velocità
! disenga la curva con gnuPlot
OPEN(UNIT=48,FILE="data")
DO i=1,contatore
	WRITE(48,*) distanzaGalassia(i), velRec(i)
END DO
CLOSE(48)

CALL SYSTEM("gnuplot -p data_plot_hubble.plt")

! Calcola il FIT - Regressione Lineare PESATA - (migliore retta che interpola i 4 punti) 
! Uso il metodo pesato perchè la velocità ha errori indipendenti
  sumXq=0.
  sumX=0.
  sumY=0.
  sumXY=0.
  sumYaX=0.
  sumW=0.
  DO j=1, contatore
  	w(j)=1/velRecError(j)**2
	sumXq=sumXq+w(j)*distanzaGalassia(j)**2
	sumX=sumX+w(j)*distanzaGalassia(j)
	sumY=sumY+w(j)*velRec(j)
	sumXY=sumXY+w(j)*distanzaGalassia(j)*velRec(j)
	sumW=sumW+w(j)
  END DO
  Delta=sumW*sumXq-sumX*sumX
  A=(sumXq*sumY-sumX*sumXY)/Delta
  B=(sumW*sumXY-sumX*sumY)/Delta
! calcolo degli errori su A e B
  sigmaB=sqrt(sumW/Delta)
  sigmaA=sqrt(sumXq/Delta)
  
  PRINT *, "Costante di Hubble (pendenza) calcolata tramite regressione lineare pesata="

  WRITE (*,55) B," +/-",sigmaB," km/s/Mpc"
  PRINT *, 
  PRINT*,"Costante di Hubble calcolata tramite media pesata="
  PRINT *, 

  sommanum=0.
  sommaden=0.
  DO k=1,4
   tot2(k)=velRec(k)/distanzaGalassia(k)
   errtot(k)=sqrt((velRecError(k)**2)/(distanzaGalassia(k)**2) + ((velRec(k)**2)/(distanzaGalassia(k)**4))*(errDist(k)**2))
   sommanum=sommanum+(tot2(k)/(errtot(k)**2))
   sommaden=sommaden+(1/(errtot(k)**2))
   56 FORMAT(I3,(x,f6.2),A,(x,f6.2),A)
   WRITE (*,56) k,tot2(k),"+/-", errtot(k)
  END DO

  mediaH=(sommanum/sommaden)
  errmediaH=sqrt(1./sommaden)
  57 FORMAT((x,f6.2),A,(x,f6.2),A)
  WRITE (*,57) mediaH," +/-",errmediaH,"km/s/Mpc"
  PRINT *, 

END PROGRAM hubble





SUBROUTINE spline(fileName,steps,magMedia,devStdMag,periodoMedio,devStdPeriodo)
! subroutine per calcolare la magnitudine media e il periodo di ognuna delle 4 Cepheidi
  IMPLICIT NONE
  INTEGER:: i,j,k,k1,k2,m,ii,jj,counter,posmin,nd,interval,steps,startMin,endMin
  REAL*8, ALLOCATABLE:: tempCurve(:,:), fx(:), x(:), c(:), g(:), e(:), f(:), f2(:), inputdata(:,:),provv(:,:),minimo2(:,:)
  REAL*8, ALLOCATABLE:: matgauss(:,:), a(:,:)
  REAL*8:: x_int,prod,summa,sum_prec,errore,factor,somma,fx_int,dx,dydx1,dydx2,minimo(300,3),massimo(300,3),periodo(300)
  REAL*8:: periodoMedio, sommaPeriodo, somma1, devStdPeriodo, devStdMag, min_curve, max_curve, maxbuono(30,3), minbuono(30,3) 
  REAL*8:: totSomme, magMedia, totaleMag
  CHARACTER(LEN=16):: fileName
  
! LEGGE i DATI dal FILE passato dal parametro della subroutine
  OPEN(99, file=fileName)
  counter=0
  DO !conta i dati nel file
  	READ(99,*, END=888) !888 è un etichetta di riga/label a cui saltare
  	counter=counter+1
  END DO
  888 CONTINUE !label uscita ciclo count 
  PRINT *, 
  PRINT *, fileName  
  PRINT *, "Dati fotometrici nel file=",counter
  PRINT *,
  
  nd=counter-2  
  
  !alloco tutte le matrici in base al numero di dati nel file dat
  ALLOCATE(inputdata(2,counter)) 
  ALLOCATE(f2(counter)) 
  ALLOCATE(provv(2,counter)) 
  ALLOCATE(minimo2(2,counter)) 
  ALLOCATE(c(counter)) 
  ALLOCATE(x(counter)) 
  ALLOCATE(fx(counter)) 
  ALLOCATE(e(nd)) 
  ALLOCATE(f(nd)) 
  ALLOCATE(g(nd)) 
  ALLOCATE(matgauss(nd,nd))
  
  !alloco la matrice per i dati della curva di luce calcolata nella subroutine
  ALLOCATE(tempCurve(2,steps))
  
  REWIND 99 !riavvolge il file dati 99 dall'inizio
  
  DO j=1,counter
	READ(99,*) (inputdata(i,j), i=1,2) !è un ciclo DO su una sola riga
	!WRITE(*,90) (inputdata(i,j), i=1,2)
  END DO

! SORT DELLA MATRICE DATI sulla prima colonna
  DO i=1,counter-1
  	minimo2(1,1)=inputdata(1,i)
  	minimo2(2,1)=inputdata(2,i)
	posmin=i
	DO j=i+1,counter
		IF(inputdata(1,j)<minimo2(1,1)) THEN
			minimo2(1,1)=inputdata(1,j)
			minimo2(2,1)=inputdata(2,j)
			posmin=j
		END IF
	END DO
	DO jj=1, 2
		provv(jj,1)=inputdata(jj,i)
		inputdata(jj,i)=minimo2(jj,1)
		inputdata(jj,posmin)=provv(jj,1)
	END DO
END DO

!PRINT *, "matrice ordinata"
!DO j=1, counter
!	WRITE(*,90) (inputdata(i,j), 	i=1,2)
!END DO

! Creo la matrice tridiagonale (formata da (n-2)x(n-2) elementi)
!PRINT *, "  f,e,g,c"

DO i=1,nd
	  f(i)=2.*(inputdata(1,i+2)-inputdata(1,i))
	  g(i)=inputdata(1,i+2)-inputdata(1,i+1)
	  e(i)=inputdata(1,i+1)-inputdata(1,i)
	  c(i)=6./(inputdata(1,i+2)-inputdata(1,i+1))*(inputdata(2,i+2)-inputdata(2,i+1))+&
	       6./(inputdata(1,i+1)-inputdata(1,i))*(inputdata(2,i)-inputdata(2,i+1))
END DO

matgauss=0
DO i=1, nd
	matgauss(i,i)=f(i)
	IF (i/=nd) THEN
		matgauss(i+1,i)=e(i+1)
		matgauss(i,i+1)=g(i)
	END IF
END DO
!PRINT *, "matrice gauss"
!DO j=1, nd
!	WRITE(*,91) (matgauss(i,j), i=1,nd)
!END DO

!GAUSS-JORDAN : calcola la soluzione del sistema lineare
  ALLOCATE(a(nd,nd))
  a=matgauss
  
  DO i=1, nd
	factor=a(i,i)
	a(i,:)=a(i,:)/factor !divido la iesima riga per factor (come fosse un ciclo DO)
	c(i)=c(i)/factor
	DO j=1,nd
	 IF (i/=j) THEN
		factor=a(j,i)
		DO k=1,nd
			a(j,k)=a(j,k)-factor*a(i,k)
		END DO
		c(j)=c(j)-factor*c(i)
	 END IF
	END DO 
  END DO
  
  f2=0 !metto a zero il vettore soluzioni (derivate seconde)

  !PRINT *, "soluzioni f derivate seconde"
  DO i=1, counter
    if (i/=counter) f2(i+1)=c(i) !sostituisco con c - metto i+1 per avere coerenza di indici con la matrice inputdata()
	x(i)=inputdata(1,i) ! per brevità metto gli x della matrice inputdata nel vettore x (per usarli nella formula successiva)
	fx(i)=inputdata(2,i) ! per brevità metto gli f(x) della matrice inputdata nel vettore fx (per usarli nella formula successiva)
  END DO

! calcola la curva di luce della cefeide in step dx piccoli (parametro passato alla subroutine)
! creo lo step incrementale della x (dx)

dx=ABS((x(1)-x(counter)))/steps

DO j=1, steps

  x_int=x(1)+dx*(j-1)

  !Controlla l'intervallo in cui si trova la x_int
  DO i=1, counter
  	IF (x_int<=x(i)) THEN 
		EXIT
	END IF
  END DO
  IF (x_int/=x(1)) i=i-1
  !print *, "intervallo ", i !corrisponde all'indice (i-1) nella formula
  IF (i==0) THEN
  	PRINT *, "Valore di x inferiore all'intervallo minimo"
  	STOP
  END IF
  IF (i>=counter) THEN
  	PRINT *, "Valore di x superiore all'intervallo massimo"
  	STOP
  END IF

  !CALCOLA il VALORE DELLA FUNZIONE in x_int
  
  fx_int=f2(i)/(6.*(x(i+1)-x(i)))*(x(i+1)-x_int)**3+ &
         f2(i+1)/(6.*(x(i+1)-x(i)))*(x_int-x(i))**3+ &
		 (fx(i)/(x(i+1)-x(i))-(f2(i)*(x(i+1)-x(i))/6.))*(x(i+1)-x_int)+ &
		 (fx(i+1)/(x(i+1)-x(i))-(f2(i+1)*(x(i+1)-x(i))/6.))*(x_int-x(i))

  tempCurve(1,j)=x_int
  tempCurve(2,j)=fx_int
END DO

m=1
!Trovo minimi della curva di luce
DO j=1, steps-2
 !PRINT *, i,j, "x=", tempCurve(1,j), "fx=", tempCurve(2,j), "dy/dx=",dydx1
 !calcolo la derivata prima in 2 punti consequenziali
 dydx1=(tempCurve(2,j)-tempCurve(2,j+1))/(tempCurve(1,j)-tempCurve(1,j+1))
 dydx2=(tempCurve(2,j+1)-tempCurve(2,j+2))/(tempCurve(1,j+1)-tempCurve(1,j+2))
 !se c'è un cambio di segno da (-) a (+) quello è un min
 IF ((dydx1<=0).AND.(dydx2>0)) THEN
   minimo(m,1)=tempCurve(1,j+1)
   minimo(m,2)=tempCurve(2,j+1)
   minimo(m,3)=j+1
   m=m+1
 END IF
END DO

!PRINT *, "NUMERO MINIMI=", m-1

!prendi il min assoluto (min_curve)
 min_curve=minimo(1,2)
 DO i=2, m-1
      IF (minimo(i,2)<min_curve) THEN 
	 	min_curve=minimo(i,2)
	  END IF
 END DO
 PRINT *, "MINIMO ASSOLUTO (Magnitudine)=", min_curve

!scegli solo i minimi REALI che servono per il calcolo del periodo (entro una certa percentuale da min assoluto)
k1=1
DO i=1, m-1
   IF ((minimo(i,2)/min_curve)<1.004) THEN
   	   minbuono(k1,3)=minimo(i,3) !indice dell'array nella sequenza di valori di magnitudine
	   minbuono(k1,2)=minimo(i,2) !magnitudine
	   minbuono(k1,1)=minimo(i,1) !tempo
	   k1=k1+1
   END IF
END DO
! k1-1 è il numero di minimi REALI trovati

m=1
!Trovo MASSIMI della curva di luce
DO j=1, steps-2
 !calcolo la derivata prima in 2 punti consequenziali
 dydx1=(tempCurve(2,j)-tempCurve(2,j+1))/(tempCurve(1,j)-tempCurve(1,j+1))
 dydx2=(tempCurve(2,j+1)-tempCurve(2,j+2))/(tempCurve(1,j+1)-tempCurve(1,j+2))
 !se c'è un cambio di segno da (+) a (-) quello è un MAX
 IF ((dydx1>0).AND.(dydx2<=0)) THEN
   massimo(m,1)=tempCurve(1,j+1)
   massimo(m,2)=tempCurve(2,j+1)
   massimo(m,3)=j+1
   m=m+1
 END IF
END DO

!PRINT *, "NUMERO MASSIMI=", m-1

!prendi il max assoluto (max_curve)
 max_curve=massimo(1,2)
 DO i=2, m-1
      IF (massimo(i,2)>max_curve) THEN 
	 	max_curve=massimo(i,2)
	  END IF
 END DO
 PRINT *, "MASSIMO ASSOLUTO (Magnitudine)=", max_curve

PRINT *,
!scegli solo i massimi REALI che servono per il calcolo del periodo (entro una certa percentuale da max assoluto)
k2=1
DO i=1, m-1
   IF ((massimo(i,2)/max_curve)>0.9965) THEN
   	   maxbuono(k2,3)=massimo(i,3) !indice dell'array nella sequenza di valori di magnitudine
	   maxbuono(k2,2)=massimo(i,2) !magnitudine
	   maxbuono(k2,1)=massimo(i,1) !tempo
	   k2=k2+1
   END IF
END DO
! k2-1 è il numero di massimi REALI trovati

sommaPeriodo=0
!calcolo il PERIODO come media delle differenze fra i minimi
DO i=1, k1-2
   periodo(i)=minbuono(i+1,1)-minbuono(i,1)
   sommaPeriodo=sommaPeriodo+periodo(i)
END DO

IF (fileName == "ceph_ngc0925.dat") THEN !uso anche dati del max della curva 2 (perchè ho due soli minimi)
	periodo(i)=maxbuono(2,1)-maxbuono(1,1)
	sommaPeriodo=sommaPeriodo+periodo(i)
	k1=k1+1
END IF

periodoMedio=sommaPeriodo/(k1-2)	
!calcolo la deviazione standard sul periodo
somma1=0
DO i=1, k1-2
  somma1=somma1+(periodo(i)-periodoMedio)**2
END DO
devStdPeriodo=sqrt(somma1/(k1-3))

54 FORMAT(A,(x,f7.3),A,(x,f7.3))  
WRITE (*,54) "PERIODO MEDIO", periodoMedio, " +/-", devStdPeriodo

!calcolo la magnitudine media su un numero di periodi interi
totSomme=0
totaleMag=0
startMin=minbuono(1,3)   !dal primo
endMin=minbuono(k1-1,3)-1 !al k-1 esimo minimo reale
DO i=startMin, endMin
	totaleMag=totaleMag+tempCurve(2,i)
	totSomme=totSomme+1
END DO
magMedia=totaleMag/totSomme

!calcolo la deviazione standard sulla magnitudine
somma1=0
DO i=startMin, endMin
  somma1=somma1+(tempCurve(2,i)-magMedia)**2
END DO
devStdMag=sqrt(somma1/(endMin-1))

WRITE (*,54) "MAGNITUDINE MEDIA", magMedia, " +/-", devStdMag

!disenga la curva delle 4 cefeidi con gnuPlot
OPEN(UNIT=48,FILE="data")
DO i=1,steps
	WRITE(48,*) tempCurve(1,i),tempCurve(2,i)
END DO
CLOSE(48)

CALL SYSTEM("gnuplot -p data_plot_" // fileName(1:12) // ".plt")

END SUBROUTINE spline
	